package cz.muni.fi.xludvic.camel.example.converter;

import org.apache.camel.Converter;
import org.apache.camel.Exchange;
import org.apache.camel.TypeConverter;

import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.SearchResult;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by jludvice on 25.2.15.
 */


public class MyConverter {


    @Converter
    public static Map convertSearchToMap(SearchResult result, Exchange exchange) throws NamingException {
        if (result == null) {
            return null;
        }

        Attributes attrs = result.getAttributes();
        NamingEnumeration<? extends Attribute> enumeration = attrs.getAll();

        Map<String, String> map= new HashMap<String, String>();

        boolean hasExchange = exchange != null;
        TypeConverter converter = null;

        if(hasExchange) {
            converter = exchange.getContext().getTypeConverter();
        }

        while (enumeration.hasMore()) {
            Attribute a = enumeration.next();
            String id = a.getID();

            NamingEnumeration<?> values = a.getAll();

            while(values.hasMore()){
                String val = null;
                if (hasExchange) {
                    val = converter.convertTo(String.class, exchange, values.next());
                }
                else{
                    try{
                        val = (String)values.next();
                    }
                    catch(Exception e){
                        // pass
                    }
                }
                map.put(id, val);

            }
        }
        return map;
    }
}
