# Apache Camel Intro
Josef Ludvíček, seminář Lasaris 26. 2. 2015

## Zmíněné technologie

* JBoss Fuse
  * OSGI kontejner
  * info: http://www.jboss.org/products/fuse/overview/
* Apache ActiveMQ
    * součást JBoss Fuse
    * messaging server pro JMS a další protokoly
    * info http://activemq.apache.org/
* Apache Camel
    * integrační framework, více v prezentaci
* Hawt.io 
    * webová konzole
    * info http://hawt.io/

## Další zdroje
* Apache Camel site: http://camel.apache.org/
* kniha Camel in Action http://www.manning.com/ibsen/
* bakalářská práce Josef Ludvíček, kapitola 3 https://is.muni.cz/auth/th/374268/fi_b/

## Prezentace
* slajdy přiloženy jako pdf
* vytvořeno pomocí [Reveal.js](https://github.com/hakimel/reveal.js/)
* pro spuštění prezentace:
```
cd prezentace-revealjs-zdroj
npm install
grunt serve
```
* závislosti pro spuštění prezentace
    * nodejs
    * npm (node package manager)
    * grunt-cli (command line interface pro grunt task runner)

## Zdrojové kódy
### python parser IS MU
* závislosti 
    * mechanize
    * beautifulsoup4
* spuštění
    * python manage.py runserver 0.0.0.0:9900
    * url http://localhost:9900/parse/uco_studenta
    
### ukázaná camel aplikace
* závislosti
    * běžící ActiveMQ/JBoss Fuse
    * vytvořený uživatel `jack:sparrow` (`$FUSE_HOME/etc/users.properties`)
    * síťová dostupnost `ldap.fi.muni.cz` => funguje ze sítě FI MU
    * běžící python aplikace
* konfigace
    * přípojení k e-mail serveru 
        * `src/main/resources/config.properties` 
    * spring - připojení k LDAPu a ActiveMQ
        * `src/main/resources/META-INF/spring/camel-context.xml`
        * zde jsou definovane i camel cesty

### jednoduchý "camel hello world"
* vytvořit si novou aplikaci např. pomocí `camel-archetype-spring` http://camel.apache.org/camel-maven-archetypes.html
  